public class UE18Aufgabe12 {
	public static void main(String[] args) {
		Euro euro = new Euro(2);
		euro.print(); // Ausgabe: 2.0 Euro
		DM dm = new DM(4);
		dm.print(); // Ausgabe: 4.0 DM
		Lire lire = new Lire(600);
		lire.print(); // Ausgabe: 600.0 Lire
		euro.addiere(dm); // 2.0 Euro + 4.0 DM
		euro.print(); // Ausgabe: 4.045168 Euro
		lire.addiere(euro); // 6.0 Ellen + 3.216 Euro
		lire.print(); // Ausgabe: 8439.472868217055 Lire
	}
}

class Euro {

	double betrag;

	Euro(double b) {
		this.betrag = b;
	}

	void print() {
		System.out.println(this.betrag + " Euro");
	}

	void addiere(Euro e) {
		this.betrag += e.betrag;
	}
}

class DM extends Euro {

	DM(double b) {
		super(b * 0.511292);
	}

	@Override
	void print() {
		System.out.println(this.betrag / 0.511292 + " DM");
	}
}

class Lire extends Euro {

	Lire(double b) {
		super(b * 0.000516);
	}

	@Override
	void print() {
		System.out.println(this.betrag / 0.000516 + " Lire");
	}
}
