
public class UE18Aufgabe2 {

	public static void main(String[] args) {
		Name n1 = new Name("Mehl");
		Name n2 = new AbkName("Messerspitze", "Msp");
		Name n3 = new AbkName("Tasse");
		n1.schreib();
		n2.schreib();
		n3.schreib();
	}
}

class Name {

	private String name;

	Name(String name) {
		this.name = name;
	}

	void schreib() {
		System.out.println(this.name);
	}
}

class AbkName extends Name {
	
	private String abkue;
	
	AbkName(String name) {
		super(name);
		abkue = null;
	}

	AbkName(String name, String abk) {
		super(name);
		this.abkue = abk;
	}
	
	@Override
	void schreib() {
		if (abkue != null) {
			System.out.print(this.abkue + ".: ");
		}
		super.schreib();
	}
}
