class NimmSpieler {
	public int liefereZahl(int aktZahl) {
		return IO.readInt("1 oder 2 eingeben:");
	}
}

class UE18Aufgabe6 {
	// Hauptprogramm
	public static void main(String[] args) {
		NimmSpieler spielerA = new NimmSpieler();
		NimmSpieler spielerB = new NimmProgramm();
		NimmSpiel spiel = new NimmSpiel(spielerA, spielerB,
				IO.readInt("Startzahl: "));
		spiel.go();
	}

	// Hauptprogramm (Demo)
	public static void main2(String[] args) throws Exception {
		String spieler1 = args[0];
		String spieler2 = args[1];
		NimmSpieler spielerA = (NimmSpieler) (Class.forName(spieler1)
				.newInstance());
		NimmSpieler spielerB = (NimmSpieler) (Class.forName(spieler2)
				.newInstance());
		NimmSpiel spiel = new NimmSpiel(spielerA, spielerB,
				IO.readInt("Startzahl: "));
		spiel.go();
	}
}

class NimmSpiel {

	// Attribute
	NimmSpieler spielerA, spielerB, aktSpieler;
	int zahl;

	public NimmSpiel(NimmSpieler spielerA, NimmSpieler spielerB, int zahl) {
		this.spielerA = spielerA;
		this.spielerB = spielerB;
		this.aktSpieler = spielerA;
		this.zahl = zahl;
	}

	public void go() {
		IO.println("Spieler A ist an der Reihe");
		while (this.zahl > 0) {
			IO.println("Zahl: " + this.zahl);
			int spielerZahl = this.aktSpieler.liefereZahl(this.zahl);
			if (!(spielerZahl == 1 || spielerZahl == 2)) {
				IO.println("Verloren: ungueltige Zahl!");
				return;
			}
			this.zahl -= spielerZahl;
			if (this.zahl > 0) {
				if (this.aktSpieler == spielerA) {
					this.aktSpieler = spielerB;
					IO.println("Spieler B ist an der Reihe");
				} else {
					this.aktSpieler = spielerA;
					IO.println("Spieler A ist an der Reihe");
				}
			}
		}
		if (this.aktSpieler == spielerA)
			IO.println("Spieler A hat gewonnen!");
		else
			IO.println("Spieler B hat gewonnen!");
	}
}

class NimmProgramm extends NimmSpieler {
	@Override
	public int liefereZahl(int aktZahl) {
		if (aktZahl % 3 == 1) {
			return 1;
		} else {
			return 2;
		}
	}
}
